<?xml version="1.0" encoding="UTF-8"?>
<!-- This stylesheet creates a table corresponding to the argumentation relations () named entities (with their types) 
	  using the files: ES2002a.argumentationrels.xml and the 'ar' ontology.
	  Must be used in relation to the argumentstructs tables to which both src (source) and trg (target) refer.
      Format of the table: meeting_id, annotator, ar_id, ar_type, ar_gloss, src_speaker_id, src_nxt_speaker, src_annotator, src_id, trg_speaker_id, trg_nxt_speaker, trg_annotator, trg_id  
      (based on namedEntities.xslt and dialogueActs.xslt)
      *************************************
		<ar nite:id="ES2002a.argumentationrels.Erik.1">
			  <nite:pointer role="source"  href="ES2002a.B.argumentstructs.xml#id(ES2002a.B.argumentstructs.Erik.1)"/>
			  <nite:pointer role="target"  href="ES2002a.D.argumentstructs.xml#id(ES2002a.D.argumentstructs.Erik.2)"/>
			  <nite:pointer role="type"  href="ar-types.xml#id(art_3)"/>
      *************************************
      Andrei Popescu-Belis, Feb 2007
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:nite="http://nite.sourceforge.net/">
	<xsl:output method="text" version="1.0" encoding="ISO-8859-1" indent="no"/>
	<xsl:param name="artypesfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\DATA\AMI-data-020207\ontologies\ar-types.xml</xsl:param>
	<xsl:param name="artypes" select="document($artypesfile)"/>
	<xsl:param name="speakerfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\DATA\AMI-data-020207\corpusResources\meetings.xml</xsl:param>
	<xsl:param name="speakerlist" select="document($speakerfile)"/>
	<!-- ************************************************ -->
	<xsl:template match="nite:root">
		<xsl:param name="meeting_id" select="substring-before(@nite:id,'.')"/>
		<xsl:param name="meeting_speakers2" select="$speakerlist//meeting[@observation = $meeting_id]"/>
		<xsl:apply-templates select="ar">
			<xsl:with-param name="meeting_speakers" select="$meeting_speakers2"/>
		</xsl:apply-templates>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template match="ar">
		<xsl:param name="meeting_speakers"/>
		<xsl:param name="ar_id" select="@nite:id"/>
		<xsl:param name="source" select="substring-before(substring-after(nite:pointer[@role='source']/@href,'xml#id('),')')"/>
		<xsl:param name="target"  select="substring-before(substring-after(nite:pointer[@role='target']/@href,'xml#id('),')')"/>
		<!-- meeting_id -->
		<xsl:value-of select="substring-before(@nite:id,'.')"/> <!-- nite:id example: ES2002a.argumentationrels.Erik.1 -->
		<xsl:text>	</xsl:text>
		<!-- annotator -->
		<xsl:value-of select="substring-before(substring-after(substring-after(@nite:id,'.'),'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- ar_id -->
		<xsl:value-of select="substring-after(substring-after(substring-after(@nite:id,'.'),'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- ar_type and ar_gloss -->
				<xsl:call-template name="ar_names">
			<xsl:with-param name="niteid" select="substring-before(substring-after(nite:pointer[@role='type']/@href,'ar-types.xml#id('),')')"/>
		</xsl:call-template>
		<!-- src_speaker_id -->
		<xsl:value-of select="$meeting_speakers/speaker[@nxt_agent=substring-before(substring-after($source,'.'),'.')]/@global_name"/>
		<xsl:text>	</xsl:text>
		<!-- src_nxt_speaker -->
		<xsl:value-of select="substring-before(substring-after($source,'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- src_annotator -->
		<xsl:value-of select="substring-before(substring-after(substring-after(substring-after($source,'.'),'.'),'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- src_id -->
		<xsl:value-of select="substring-after(substring-after(substring-after(substring-after($source,'.'),'.'),'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- trg_speaker_id -->
		<xsl:value-of select="$meeting_speakers/speaker[@nxt_agent=substring-before(substring-after($target,'.'),'.')]/@global_name"/>
		<xsl:text>	</xsl:text>
		<!-- trg_nxt_speaker -->
		<xsl:value-of select="substring-before(substring-after($target,'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- trg_annotator -->
		<xsl:value-of select="substring-before(substring-after(substring-after(substring-after($target,'.'),'.'),'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- trg_id -->
		<xsl:value-of select="substring-after(substring-after(substring-after(substring-after($target,'.'),'.'),'.'),'.')"/>
		<xsl:text>&#x0A;</xsl:text>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template name="ar_names">
		<xsl:param name="niteid"/> <!-- encoded as art_7 -->
		<!-- ar_type -->
		<xsl:value-of select="$artypes//ar-type[@nite:id=$niteid]/@name"/> <!-- or name? -->
		<xsl:text>	</xsl:text>
		<!-- ar_gloss -->
		<xsl:value-of select="$artypes//ar-type[@nite:id=$niteid]/@gloss"/>
		<xsl:text>	</xsl:text>
	</xsl:template>
	<!-- ************************************************ -->
</xsl:stylesheet>
