<?xml version="1.0" encoding="UTF-8"?>
<!-- This stylesheet creates a table corresponding to the utterances and dialogue act annotations using the files: XX1234z.W.dialog-act.xml -->
<!-- Format of the table: meeting_id, speaker_id, nxt_speaker, da_id, annotator, da_name, da_gloss, starttime, endtime, startword, endword, words -->
<!-- Andrei Popescu-Belis, 18 Jun 2006 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:nite="http://nite.sourceforge.net/">
	<xsl:output method="text" version="1.0" encoding="ISO-8859-1" indent="no"/>
	<xsl:param name="wordfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\AMI-data-private\words\ES2003b.A.words.xml</xsl:param>
	<xsl:param name="wordfilecontents" select="document($wordfile)"/>
	<xsl:param name="datypesfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\AMI-data-private\ontologies\da-types.xml</xsl:param>
	<xsl:param name="datypes" select="document($datypesfile)"/>
	<xsl:param name="speakerfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\AMI-data-private\corpusResources\meetings.xml</xsl:param>
	<xsl:param name="speakerlist" select="document($speakerfile)"/>
	<!-- ************************************************ -->
	<xsl:template match="nite:root">
		<xsl:param name="meeting_id" select="substring-before(@nite:id,'.')"/>
		<xsl:param name="nxt_speaker" select="substring-before(substring-after(@nite:id,'.'),'.')"/>
		<xsl:apply-templates select="dact">
			<xsl:with-param name="speaker_id" select="$speakerlist//meeting[@observation = $meeting_id]/speaker[@nxt_agent = $nxt_speaker]/@global_name"/>
		</xsl:apply-templates>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template match="dact">
		<xsl:param name="speaker_id"/> 
		<xsl:param name="seg_id" select="@nite:id"/>
		<!-- meeting_id -->
		<xsl:value-of select="substring-before(@nite:id,'.')"/> <!-- nite:id example: ES2003b.A.dialog-act.vkaraisk.4 -->
		<xsl:text>	</xsl:text>
		<!-- speaker_id -->
		<xsl:value-of select="$speaker_id"/>
		<xsl:text>	</xsl:text>
		<!-- nxt_speaker -->
		<xsl:value-of select="substring-before(substring-after(@nite:id,'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- da_id -->
		<xsl:value-of select="substring-after(substring-after(substring-after(substring-after(@nite:id,'.'),'.'),'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- annotator -->
		<xsl:value-of select="substring-before(substring-after(substring-after(substring-after(@nite:id,'.'),'.'),'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<xsl:call-template name="dactsnames">
			<xsl:with-param name="niteid" select="substring-before(substring-after(nite:pointer[@role='da-aspect']/@href,'da-types.xml#id('),')')"/>
		</xsl:call-template>
		<xsl:choose>
			<xsl:when test="contains(nite:child/@href,'..')">
				<xsl:call-template name="words">
					<xsl:with-param name="start" select="substring-before(substring-after(substring-after(nite:child/@href,'#id('),'words'),')..')"/>
					<xsl:with-param name="end" select="substring-before(substring-after(substring-after(nite:child/@href,'..id('),'words'),')')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="words">
					<xsl:with-param name="start" select="substring-before(substring-after(substring-after(nite:child/@href,'#id('),'words'),')')"/>
					<xsl:with-param name="end" select="substring-before(substring-after(substring-after(nite:child/@href,'#id('),'words'),')')"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text>&#xA;</xsl:text>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template name="dactsnames">
		<xsl:param name="niteid"/> <!-- encoded as ami_da_N -->
		<!-- da_name -->
		<xsl:value-of select="$datypes//da-type[@nite:id=$niteid]/@name"/>
		<xsl:text>	</xsl:text>
		<!-- da_gloss -->
		<xsl:value-of select="$datypes//da-type[@nite:id=$niteid]/@gloss"/>
		<xsl:text>	</xsl:text>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template name="words">
		<xsl:param name="start"/>
		<xsl:param name="end"/>
		<!-- starttime -->
		<xsl:value-of select="$wordfilecontents//*[$start = number(substring-after(@nite:id,'words'))]/@starttime"/>
		<xsl:text>	</xsl:text>
		<!-- endtime -->
		<xsl:value-of select="$wordfilecontents//*[$end = number(substring-after(@nite:id,'words'))]/@endtime"/>
		<xsl:text>	</xsl:text>
		<!-- startword -->		
		<xsl:value-of select="$start"/>
		<xsl:text>	</xsl:text>
		<!-- endword -->
		<xsl:value-of select="$end"/>
		<xsl:text>	</xsl:text>
		<!-- words -->
		<xsl:apply-templates select="$wordfilecontents//*[($start &lt;= number(substring-after(@nite:id,'words'))) and (number(substring-after(@nite:id,'words')) &lt;= $end)]"/>
	</xsl:template>
<!-- ************************************************ -->
	<xsl:template match="w|disfmarker|vocalsound|gap">
		<xsl:choose>
			<xsl:when test="position()=1"/>
			<xsl:otherwise><xsl:text> </xsl:text></xsl:otherwise>
		</xsl:choose>
			<xsl:choose>
			<xsl:when test="string-length(.)!=0">
				<xsl:value-of select="."/>
			</xsl:when>
			<xsl:otherwise>[<xsl:value-of select="name()"/>]</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
