<?xml version="1.0" encoding="UTF-8"?>
<!-- This stylesheet creates a table corresponding to the annotation of the focus of attention -->
<!-- The temporal indications are present in the NN1234z.X.foa.xml files, so the only external files to be used are the ones with the speaker codes -->
<!-- Format of the table: meeting_id, speaker_id, nxt_speaker, foa_id, annotator, starttime, endtime, what_type, what_id, what_nxt, what_role -->
<!-- In the case the "where" is a person, we record his/hers speaker_id, but also here nxt code in the meeting (A,B,C,D) and the role (since it is in the file already) --> 
<!-- Andrei Popescu-Belis, June 2006 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:nite="http://nite.sourceforge.net/">
	<xsl:output method="text" version="1.0" encoding="ISO-8859-1" indent="no"/>
	<xsl:param name="speakerfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\DATA\AMI-data-020207\corpusResources\meetings.xml</xsl:param>
	<xsl:param name="speakerlist" select="document($speakerfile)"/>
	<!-- ************************************************ -->
	<xsl:template match="nite:root">
		<xsl:param name="meeting_id" select="substring-before(substring-after(@nite:id,'_'),'_')"/>
		<xsl:param name="nxt_speaker" select="substring-before(substring-after(substring-after(@nite:id,'_'),'_'),'.')"/>
		<xsl:apply-templates select="//foa">
			<xsl:with-param name="speaker_id" select="$speakerlist//meeting[@observation = $meeting_id]/speaker[@nxt_agent = $nxt_speaker]/@global_name"/>
		</xsl:apply-templates>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template match="foa">
		<xsl:param name="speaker_id"/> 
		<xsl:param name="foa_id" select="@nite:id"/>
		<xsl:param name="where_agent" select="@nxt_agent"/>
		<!-- meeting_id -->
		<xsl:value-of select="substring-before(substring-after(@nite:id,'_'),'_')"/> <!-- sample id: natasa_IS1002a_A.foa.2 -->
		<xsl:text>	</xsl:text>
		<!-- speaker_id -->
		<xsl:value-of select="$speaker_id"/>
		<xsl:text>	</xsl:text>
		<!-- nxt_speaker -->
		<xsl:value-of select="substring-before(substring-after(substring-after(@nite:id,'_'),'_'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- foa_id --> <!-- some are written as 1,234 -->
		<xsl:value-of select="translate(substring-after(substring-after(@nite:id,'.'),'.'),',','')"/>
		<xsl:text>	</xsl:text>
		<!-- annotator -->
		<xsl:value-of select="substring-before(@nite:id,'_')"/> <!-- pas clair -->
		<xsl:text>	</xsl:text>
		<!-- starttime -->
		<xsl:value-of select="@starttime"/>
		<xsl:text>	</xsl:text>
		<!-- endtime --> <!-- the last FOAs lack endtime: set to 5000 by default -->
		<xsl:choose>
			<xsl:when test="@endtime"><xsl:value-of select="@endtime"/></xsl:when>
			<xsl:otherwise>5000</xsl:otherwise>
		</xsl:choose>  
		<xsl:text>	</xsl:text>
		<!-- what_type -->
		<xsl:value-of select="@type"/>
		<xsl:text>	</xsl:text>
		<!-- what_id -->
		<xsl:choose>
			<xsl:when test="(@type = 'place')">
				<xsl:value-of select="@place"/>
				<xsl:text>	nil	nil</xsl:text>
			</xsl:when>
			<xsl:when test="(@type = 'person')">
				<xsl:value-of select="$speakerlist//meeting[@observation = substring-before(substring-after($foa_id,'_'),'_')]/speaker[@nxt_agent = $where_agent]/@global_name"/>
				<xsl:text>	</xsl:text>
				<xsl:value-of select="@nxt_agent"/>
				<xsl:text>	</xsl:text>
				<xsl:value-of select="@role"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>nil	nil	nil</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text>
</xsl:text>
	</xsl:template>
</xsl:stylesheet>
