<?xml version="1.0" encoding="UTF-8"?>
<!-- This stylesheet creates a table corresponding to the annotation of headGesture -->
<!-- The temporal indications are present in the NN1234z.X.head.xml files, so the only external files to be used are the ones with the speaker codes -->
<!-- Format of the table: meeting_id, speaker_id, nxt_speaker, head_gesture_id, annotator, starttime, endtime,  head_gesture_type, hand_gesture_form -->
<!-- Andrei Popescu-Belis, June 2006 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:nite="http://nite.sourceforge.net/">
	<xsl:output method="text" version="1.0" encoding="ISO-8859-1" indent="no"/>
	<xsl:param name="speakerfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\AMI-data-private\corpusResources\meetings.xml</xsl:param>
	<xsl:param name="speakerlist" select="document($speakerfile)"/>
	<!-- ************************************************ -->
	<xsl:template match="nite:root">
		<xsl:param name="meeting_id" select="substring-before(substring-after(@nite:id,'_'),'_')"/>
		<xsl:param name="nxt_speaker" select="substring-before(substring-after(substring-after(@nite:id,'_'),'_'),'.')"/>
		<xsl:apply-templates select="//head">
			<xsl:with-param name="speaker_id" select="$speakerlist//meeting[@observation = $meeting_id]/speaker[@nxt_agent = $nxt_speaker]/@global_name"/>
		</xsl:apply-templates>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template match="head">
		<xsl:param name="speaker_id"/>
		<xsl:param name="head_id" select="@nite:id"/>
		<!-- meeting_id -->
		<xsl:value-of select="substring-before(substring-after(@nite:id,'_'),'_')"/> <!-- sample id: tmigaz_ES2003a_A.head.9 -->
		<xsl:text>	</xsl:text>
		<!-- speaker_id -->
		<xsl:value-of select="$speaker_id"/>
		<xsl:text>	</xsl:text>
		<!-- nxt_speaker -->
		<xsl:value-of select="substring-before(substring-after(substring-after(@nite:id,'_'),'_'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- head_gesture_id --> <!-- just in case some are written as 1,234 -->
		<xsl:value-of select="translate(substring-after(substring-after(@nite:id,'.'),'.'),',','')"/>
		<xsl:text>	</xsl:text>
		<!-- annotator -->
		<xsl:value-of select="substring-before(@nite:id,'_')"/> <!-- pas clair -->
		<xsl:text>	</xsl:text>
		<!-- starttime -->
		<xsl:value-of select="@starttime"/>
		<xsl:text>	</xsl:text>
		<!-- endtime --> <!-- the last headGestures lack endtime: set to 5000 by default -->
		<xsl:choose>
			<xsl:when test="@endtime"><xsl:value-of select="@endtime"/></xsl:when>
			<xsl:otherwise>5000</xsl:otherwise>
		</xsl:choose>  
		<xsl:text>	</xsl:text>
		<!-- head_gesture_type -->
		<xsl:value-of select="@type"/>
		<xsl:text>	</xsl:text>
		<!-- head_gesture_form -->
		<xsl:value-of select="@form"/>
		<xsl:text>
</xsl:text>
	</xsl:template>
</xsl:stylesheet>
