<?xml version="1.0" encoding="UTF-8"?>
<!-- This stylesheet creates a table corresponding to the named entities (with their types) using the files: XX1234z.W.dialog-act.xml and the ne ontology
      Format of the table: meeting_id, speaker_id, nxt_speaker, ne_id, annotator, ne_type, ne_abbrev, ne_keystroke, starttime, endtime, startword, endword, words 
      (very much based on dialogueActs.xslt)
      *************************************
      Andrei Popescu-Belis, Feb 2007
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:nite="http://nite.sourceforge.net/">
	<xsl:output method="text" version="1.0" encoding="ISO-8859-1" indent="no"/>
	<xsl:param name="wordfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\DATA\AMI-data-020207\words\ES2002a.A.words.xml</xsl:param>
	<xsl:param name="wordfilecontents" select="document($wordfile)"/>
	<xsl:param name="netypesfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\DATA\AMI-data-020207\ontologies\ne-types.xml</xsl:param>
	<xsl:param name="netypes" select="document($netypesfile)"/>
	<xsl:param name="speakerfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\DATA\AMI-data-020207\corpusResources\meetings.xml</xsl:param>
	<xsl:param name="speakerlist" select="document($speakerfile)"/>
	<!-- ************************************************ -->
	<xsl:template match="nite:root">
		<xsl:param name="meeting_id" select="substring-before(@nite:id,'.')"/>
		<xsl:param name="meeting_speakers2" select="$speakerlist//meeting[@observation = $meeting_id]"/>
		<xsl:apply-templates select="named-entity">
			<xsl:with-param name="meeting_speakers" select="$meeting_speakers2"/>
		</xsl:apply-templates>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template match="named-entity">
		<xsl:param name="meeting_speakers"/>
		<xsl:param name="seg_id" select="@nite:id"/>
		<xsl:param name="nxt_agent" select="substring-before(substring-after(@nite:id,'.'),'.')"/>
		<!-- meeting_id -->
		<xsl:value-of select="substring-before(@nite:id,'.')"/> <!-- nite:id example: ES2002a.A.ne.1 ... no annotator name! -->
		<xsl:text>	</xsl:text>
		<!-- speaker_id -->
		<!--xsl:value-of select="$speakerlist//meeting[@observation=substring-before($seg_id,'.')]/speaker[@nxt_agent=substring-before(substring-after($seg_id,'.'),'.')]/@global_name"/-->
		<xsl:value-of select="$meeting_speakers/speaker[@nxt_agent = $nxt_agent]/@global_name"/>
		<xsl:text>	</xsl:text>
		<!-- nxt_speaker -->
		<xsl:value-of select="substring-before(substring-after(@nite:id,'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- ne_id -->
		<xsl:value-of select="substring-after(substring-after(substring-after(@nite:id,'.'),'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- annotator -->
		<xsl:text>AMIdefault	</xsl:text>
		<xsl:call-template name="ne_names">
			<xsl:with-param name="niteid" select="substring-before(substring-after(nite:pointer[@role='type']/@href,'ne-types.xml#id('),')')"/>
		</xsl:call-template>
		<xsl:choose>
			<xsl:when test="contains(nite:child/@href,'..')">
				<xsl:call-template name="words">
					<xsl:with-param name="start" select="substring-before(substring-after(substring-after(nite:child/@href,'#id('),'words'),')..')"/>
					<xsl:with-param name="end" select="substring-before(substring-after(substring-after(nite:child/@href,'..id('),'words'),')')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="words">
					<xsl:with-param name="start" select="substring-before(substring-after(substring-after(nite:child/@href,'#id('),'words'),')')"/>
					<xsl:with-param name="end" select="substring-before(substring-after(substring-after(nite:child/@href,'#id('),'words'),')')"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text>&#x0A;</xsl:text>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template name="ne_names">
		<xsl:param name="niteid"/> <!-- encoded as ne_1234 -->
		<!-- ne_name -->
		<xsl:value-of select="$netypes//ne-type[@nite:id=$niteid]/@name"/>
		<xsl:text>	</xsl:text>
		<!-- ne_abbrev -->
		<xsl:value-of select="$netypes//ne-type[@nite:id=$niteid]/@abbrev"/>
		<xsl:text>	</xsl:text>
		<!-- ne_gloss -->
		<xsl:value-of select="$netypes//ne-type[@nite:id=$niteid]/@keystroke"/>
		<xsl:text>	</xsl:text>		
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template name="words">
		<xsl:param name="start"/>
		<xsl:param name="end"/>
		<!-- starttime -->
		<xsl:value-of select="$wordfilecontents//*[$start = number(substring-after(@nite:id,'words'))]/@starttime"/>
		<xsl:text>	</xsl:text>
		<!-- endtime -->
		<xsl:value-of select="$wordfilecontents//*[$end = number(substring-after(@nite:id,'words'))]/@endtime"/>
		<xsl:text>	</xsl:text>
		<!-- startword -->		
		<xsl:value-of select="$start"/>
		<xsl:text>	</xsl:text>
		<!-- endword -->
		<xsl:value-of select="$end"/>
		<xsl:text>	</xsl:text>
		<!-- words -->
		<xsl:apply-templates select="$wordfilecontents//*[($start &lt;= number(substring-after(@nite:id,'words'))) and (number(substring-after(@nite:id,'words')) &lt;= $end)]"/>
	</xsl:template>
<!-- ************************************************ -->
	<xsl:template match="w|disfmarker|vocalsound|gap">
		<xsl:choose>
			<xsl:when test="position()=1"/>
			<xsl:otherwise><xsl:text> </xsl:text></xsl:otherwise>
		</xsl:choose>
			<xsl:choose>
			<xsl:when test="string-length(.)!=0">
				<xsl:value-of select="."/>
			</xsl:when>
			<xsl:otherwise>[<xsl:value-of select="name()"/>]</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- ************************************************ -->
</xsl:stylesheet>
