<?xml version="1.0" encoding="UTF-8"?>
<!-- *************************************
This stylesheet creates a table corresponding to the annotation of abstractive summaries.
The only external files to be used are the ones with the speaker codes.
Format of the table: meeting_id, speaker_id, nxt_speaker, speaker_role, paragraph_type, sentence_number, sentence.
(NB: speaker_role is normally available in the metadata, but since 
it was encoded in the original summ.xml files, it is kept here too.)
Andrei Popescu-Belis, Feb 2007
****************************************-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:nite="http://nite.sourceforge.net/">
	<xsl:output method="text" version="1.0" encoding="ISO-8859-1" indent="no"/>
	<xsl:param name="speakerfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\DATA\AMI-data-020207\corpusResources\meetings.xml</xsl:param>
	<xsl:param name="speakerlist" select="document($speakerfile)"/>

	<!-- ************************************************ -->
	<xsl:template match="nite:root">
		<xsl:param name="meeting_id" select="substring-before(@nite:id,'.')"/>
		<xsl:param name="meeting_speakers2" select="$speakerlist//meeting[@observation = $meeting_id]"/>
		<xsl:apply-templates select="//sent">
			<xsl:with-param name="meeting_speakers" select="$meeting_speakers2"/>
		</xsl:apply-templates>	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template match="sent">
		<xsl:param name="meeting_speakers"/>
		<xsl:param name="meeting_id" select="substring(substring-before(@nite:id,'.'),1,7)"/>  <!-- sample @nite:id : ES2002aID.s.1 -->
		<xsl:param name="speaker_role" select="substring(substring-before(@nite:id,'.'),8,2)"/>
		<xsl:param name="speaker_id"  select="$meeting_speakers/speaker[@role = $speaker_role]/@global_name"/>
		<xsl:param name="nxt_speaker" select="$meeting_speakers/speaker[@role = $speaker_role]/@nxt_agent"/>
		<!-- meeting_id -->
		<xsl:value-of select="$meeting_id"/>
		<xsl:text>	</xsl:text>
		<!-- speaker_id -->
		<xsl:value-of select="$speaker_id"/>
		<xsl:text>	</xsl:text>
		<!-- nxt_speaker -->
		<xsl:value-of select="$nxt_speaker"/>
		<xsl:text>	</xsl:text>
		<!-- speaker_role -->
		<xsl:value-of select="$speaker_role"/>
		<xsl:text>	</xsl:text>
		<!-- paragraph_type -->
		<xsl:value-of select="substring-after(name(..),'_')"/>
		<xsl:text>	</xsl:text>
		<!-- sentence_number -->
		<xsl:value-of select="substring-after(@nite:id,'s.')"/>
		<xsl:text>	</xsl:text>
		<!-- sentence -->
		<xsl:value-of select="translate(.,'&#x0D;&#x0A;&#x09;&#xE2;&#x80;&#x93;&#x94;&#x98;&#x99;&#x9C;&#x9D;&#xEF;&#xBB;&#xBF;&#xA6;','  ')"/> <!-- because there are many UTF-8 character in the data -->
		<xsl:text>
</xsl:text>
	</xsl:template>
	<!-- ********************************************* -->
</xsl:stylesheet>
