<?xml version="1.0" encoding="UTF-8"?>
<!-- This stylesheet creates a table corresponding to the speech segments using the files: XX1234z.W.segments.xml -->
<!-- Format of the table: meeting_id, speaker_id, nxt_speaker, segment_id, annotator, starttime, endtime, channel, startword, endword, words -->
<!-- Andrei Popescu-Belis, 14 Jun 2006, update Feb 2007 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:nite="http://nite.sourceforge.net/">
	<xsl:output method="text" version="1.0" encoding="ISO-8859-1" indent="no"/>
	<xsl:param name="wordfile"></xsl:param>
	<xsl:param name="wordfilecontents" select="document($wordfile)"/>
	<xsl:param name="speakerfile">file://C:\Documents and Settings\Andrei Popescu-Belis\Mes documents\IM2phase2\AMI-data-private\corpusResources\meetings.xml</xsl:param>
	<xsl:param name="speakerlist" select="document($speakerfile)"/>
<!-- ************************************************ -->
	<xsl:template match="nite:root">
		<xsl:param name="meeting_id" select="substring-before(@nite:id,'.')"/>
		<xsl:param name="nxt_speaker" select="substring-before(substring-after(@nite:id,'.'),'.')"/>
		<xsl:apply-templates select="segment">
			<xsl:with-param name="speaker_id" select="$speakerlist//meeting[@observation = $meeting_id]/speaker[@nxt_agent = $nxt_speaker]/@global_name"/>
		</xsl:apply-templates>
	</xsl:template>
<!-- ************************************************ -->	
	<xsl:template match="segment">
		<xsl:param name="speaker_id"/>
		<xsl:param name="seg_id" select="../@nite:id"/>  <!-- example ES2002a.sync.76 -->
		<!-- meeting_id -->
		<xsl:value-of select="substring-before(@nite:id,'.')"/>
		<xsl:text>	</xsl:text>
		<!-- speaker_id -->
		<xsl:value-of select="$speaker_id"/>
		<xsl:text>	</xsl:text>
		<!-- nxt_speaker -->
		<xsl:value-of select="substring-before(substring-after(../@nite:id,'.'),'.')"/>
		<xsl:text>	</xsl:text>
		<!-- segment_id --> <!-- some are written as 1,234 -->
		<xsl:value-of select="translate(substring-after(substring-after(@nite:id,'.'),'.'),',','')"/>
		<xsl:text>	</xsl:text>
		<!-- annotator -->
		<!-- xsl:value-of select="substring-before(substring-after(@nite:id,'.'),'.')"/ -->
		<xsl:text>AMIdefault	</xsl:text>
		<!-- starttime -->
		<xsl:value-of select="@transcriber_start"/> <!-- CAUTION = alternates: transcriber_start, starttime -->
		<xsl:text>	</xsl:text>
		<!-- endtime -->
		<xsl:value-of select="@transcriber_end"/> <!-- CAUTION = alternates: transcriber_end, endtime -->
		<xsl:text>	</xsl:text>
		<!-- channel -->
		<xsl:value-of select="@channel"/>
		<xsl:text>	</xsl:text>
		<xsl:choose>
			<xsl:when test="contains(nite:child/@href,'..')">
				<xsl:call-template name="words">
					<xsl:with-param name="start" select="substring-before(substring-after(substring-after(nite:child/@href,'#id('),'words'),')..')"/>
					<xsl:with-param name="end" select="substring-before(substring-after(substring-after(nite:child/@href,'..id('),'words'),')')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="words">
					<xsl:with-param name="start" select="substring-before(substring-after(substring-after(nite:child/@href,'#id('),'words'),')')"/>
					<xsl:with-param name="end" select="substring-before(substring-after(substring-after(nite:child/@href,'#id('),'words'),')')"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text>&#xA;</xsl:text>
	</xsl:template>
	<!-- ************************************************ -->
	<xsl:template name="words">
		<xsl:param name="start"/>
		<xsl:param name="end"/>
		<!-- startword -->
		<xsl:value-of select="$start"/>
		<xsl:text>	</xsl:text>
		<!-- endword -->
		<xsl:value-of select="$end"/>
		<xsl:text>	</xsl:text>
		<!-- words -->
		<xsl:apply-templates select="$wordfilecontents//*[($start &lt;= number(substring-after(@nite:id,'words'))) and (number(substring-after(@nite:id,'words')) &lt;= $end)]"/>
	</xsl:template>
	<!-- ************************************************ -->
		<xsl:template match="w|disfmarker|vocalsound|gap">
		<xsl:choose>
			<xsl:when test="position()=1"/>
			<xsl:otherwise><xsl:text> </xsl:text></xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="string-length(.)!=0"><xsl:value-of select="."/></xsl:when>
			<xsl:otherwise>[<xsl:value-of select="name()"/>]</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
